#include <A4Stuff.h>
#include <MixedMode.h>
#include <QDOffscreen.h>


enum {
	systemTaskProcInfo = (kPascalStackBased)
};
			
enum {
	menuSelectProcInfo = (kPascalStackBased |
							STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Point *)))
	)
};

enum {
	moveWindowProcInfo = (kPascalStackBased |
							STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(WindowPtr))) |
							STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(int))) |
							STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(int))) |
							STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(Boolean)))
	)
};
	
enum {
	newWindowProcInfo = (kPascalStackBased |
					STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(void*))) |
					STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(Rect*))) |
					STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(ConstStr255Param))) |
					STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(Boolean))) |
					STACK_ROUTINE_PARAMETER(5, SIZE_CODE(sizeof(short))) |
					STACK_ROUTINE_PARAMETER(6, SIZE_CODE(sizeof(WindowPtr))) |
					STACK_ROUTINE_PARAMETER(7, SIZE_CODE(sizeof(Boolean))) |
					STACK_ROUTINE_PARAMETER(8, SIZE_CODE(sizeof(long)))
	)
};


GWorldPtr 	gWorld, gMonitor;
BitMapPtr	gScreen;
GrafPtr 	screen;

RoutineDescriptor *gSystemTaskAddr, *gMenuSelectAddr, *gMoveWindowAddr, *gNewWindowAddr;
pascal void MySystemTask(void);
pascal void MyMenuSelect(Point startPt);
pascal void MyMoveWindow(WindowPtr theWindow, int hGlobal, int vGlobal, Boolean front);
pascal WindowPtr MyNewWindow(void *wStorage, Rect *boundsRect, ConstStr255Param title, Boolean visible, short theProc, WindowPtr behind, Boolean goAwayFlag,
						long refCon);
pascal short MySystemEvent(EventRecord *theEvent);
GWorldPtr CreateOffscreen(Rect GWorldRect);
void	SetupOffscreen(GWorldPtr GWorld);

void main(void); 
RoutineDescriptor MainRD = BUILD_ROUTINE_DESCRIPTOR(kCStackBased, main);

void main(void)
{
	UniversalProcPtr theProcPtr;
	THz theZone;
	PicHandle		picture;
	
	EnterCodeResource();
	
	
	DetachResource(GetResource('INIT',2));
	
	GetCWMgrPort(&((CGrafPtr)screen));
	gScreen = &(   ((GrafPtr)screen)->portBits);
	
	theZone = GetZone();
	SetZone(SystemZone());


	//GetPort(&screenPort);
	//gScreen = &screenPort->portBits;
		
	picture = GetPicture(128);
	gWorld = CreateOffscreen((*picture)->picFrame);
	DrawPicture(picture, &(*picture)->picFrame);
		
	gMonitor = CreateOffscreen(gWorld->portRect);

	//patch SystemTask

	gSystemTaskAddr = NGetTrapAddress(_SystemTask, ToolTrap);
	theProcPtr = NewRoutineDescriptor ( (ProcPtr)MySystemTask, systemTaskProcInfo, GetCurrentArchitecture() );
	NSetTrapAddress (theProcPtr, _SystemTask, ToolTrap);

	SetZone(theZone);
	ExitCodeResource();
}


pascal void MySystemTask(void) {
	CopyBits(&(((GrafPtr)gWorld)->portBits),gScreen,&screen->portRect,&(((GrafPtr)gWorld)->portRect),39,nil);
	CALL_ZERO_PARAMETER_UPP( gSystemTaskAddr, systemTaskProcInfo);
}

GWorldPtr CreateOffscreen(Rect GWorldRect)
{
	QDErr		myQDErr;
	GWorldPtr 	worldForMe;
	
	myQDErr = NewGWorld( &worldForMe, 0, &GWorldRect, NULL, NULL, 0L );
	if (myQDErr != noErr){
	//	DebugStr("\pOh, Shit. (Take a break. Play Bolo.");
	//	DebugStr("\perror:");
	//	NumToString(myQDErr,errString);
	//	DebugStr(errString);
	}
	SetupOffscreen(worldForMe);
	
	return worldForMe;
}

void	SetupOffscreen(GWorldPtr GWorld)
{
	LockPixels( GetGWorldPixMap( GWorld ) );
	SetPort((GrafPtr)GWorld);
	EraseRect(&GWorld->portRect);
}