#include <A4Stuff.h>
#include <MixedMode.h>

enum{
	copyBitsProcInfo = (	kPascalStackBased |
							STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(PixMap *))) |
							STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(PixMap *))) |
							STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(Rect *))) |
							STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(Rect *))) |
							STACK_ROUTINE_PARAMETER(5, SIZE_CODE(sizeof(short))) |
							STACK_ROUTINE_PARAMETER(6, SIZE_CODE(sizeof(RgnHandle)))
						)
};

enum {
	stdBitsProcInfo = ( kPascalStackBased |
							STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(PixMap *))) |
							STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(Rect *))) |
							STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof(Rect *))) |
							STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof(short))) |
							STACK_ROUTINE_PARAMETER(5, SIZE_CODE(sizeof(RgnHandle)))
						)
};

GWorldPtr 		gWorld, gMonitor;
BitMapPtr		gScreen;

RoutineDescriptor *gCopyBitsAddr;
pascal void NewCopyBits(PixMap *srcMap, PixMap *destMap, Rect *srcRect, Rect *destRect, short tMode, RgnHandle maskRgn);
GWorldPtr CreateOffscreen(Rect GWorldRect);
void	SetupOffscreen(GWorldPtr GWorld);

void main(void);
RoutineDescriptor MainRD = BUILD_ROUTINE_DESCRIPTOR(kCStackBased, main);

void main(void)
{
	UniversalProcPtr theProcPtr;
	THz theZone;
	GrafPtr 		screenPort, tmp;
	PicHandle		picture;
	
	EnterCodeResource();
	
	
	DetachResource(GetResource('INIT',2));
	
	GetCWMgrPort(&((CGrafPtr)tmp));
	GetPort(&screenPort);
	gScreen = &(   ((GrafPtr)tmp)->portBits);
	
	theZone = GetZone();
	SetZone(SystemZone());


	//GetPort(&screenPort);
	//gScreen = &screenPort->portBits;
		
	//DebugStr("\pGetting picture.");
	picture = GetPicture(128);
	//DebugStr("\pCreating gWorld.");
	gWorld = CreateOffscreen((*picture)->picFrame);
	DrawPicture(picture, &(*picture)->picFrame);
		
	//DebugStr("\pCreating gMonitor.");
	gMonitor = CreateOffscreen(gWorld->portRect);
		

	//patch copybits
	gCopyBitsAddr = NGetTrapAddress(_CopyBits, ToolTrap);	
	theProcPtr = NewRoutineDescriptor( (ProcPtr)NewCopyBits, 
							copyBitsProcInfo,
							GetCurrentArchitecture() );
	NSetTrapAddress(theProcPtr, _CopyBits, ToolTrap);

	//patch stdbits
	gStdBitsAddr = NGetTrapAddress(_StdBits, ToolTrap);
	theProcPtr = NewRoutineDescriptor( (ProcPtr)MyStdBits,stdBitsProcInfo, GetCurrentArchitecture() );
	NSetTrapAddress(theProcPtr, _StdBits, ToolTrap);


	SetZone(theZone);

	ExitCodeResource();
}

pascal void NewCopyBits(PixMap *srcMap, PixMap *destMap, Rect *srcRect, Rect *destRect, short tMode, RgnHandle maskRgn)
{
	EnterCodeResource();
	
	//CALL_SIX_PARAMETER_UPP( gCopyBitsAddr, copyBitsProcInfo, *srcMap, destMap, srcRect, destRect, tMode, maskRgn);
	
	CALL_SIX_PARAMETER_UPP( gCopyBitsAddr, copyBitsProcInfo, srcMap, &(((GrafPtr)gMonitor)->portBits), srcRect, destRect, tMode, maskRgn);
	CALL_SIX_PARAMETER_UPP( gCopyBitsAddr, copyBitsProcInfo, &(((GrafPtr)gWorld)->portBits), &(((GrafPtr)gMonitor)->portBits), destRect, destRect, 39, maskRgn);
	CALL_SIX_PARAMETER_UPP( gCopyBitsAddr, copyBitsProcInfo, &(((GrafPtr)gMonitor)->portBits), destMap, destRect, destRect, tMode, maskRgn);
	ExitCodeResource();
}

pascal void MyStdBits(const BitMap *srcBits, const Rect *srcRect, const Rect *dstRect, short mode, RgnHandle maskRgn) {
	GrafPtr currPort;
	EnterCodeResource();
	
	GetPort(&currPort);
	SetPort(
	MyCopyBits(srcBits,&currPort->portBits,srcRect,dstRect,mode,maskRgn);
	ExitCodeResource();
}

GWorldPtr CreateOffscreen(Rect GWorldRect)
{
	QDErr		myQDErr;
	GWorldPtr 	worldForMe;
	
	myQDErr = NewGWorld( &worldForMe, 0, &GWorldRect, NULL, NULL, 0L );
	if (myQDErr != noErr)
		DebugStr("\pOh, Shit. (Take a break. Play Bolo.");
	
	SetupOffscreen(worldForMe);
	
	return worldForMe;
}

void	SetupOffscreen(GWorldPtr GWorld)
{
	LockPixels( GetGWorldPixMap( GWorld ) );
	SetPort((GrafPtr)GWorld);
	EraseRect(&GWorld->portRect);
}